﻿using HarmonyLib;
using System.Collections;
using System.Reflection;
using UnityEngine;
using UnityEngine.Networking;
using System.Collections.Generic;
using System;

public class GawrGuraShark : Mod
{
    private AssetBundle asset;
    Harmony harmonyInstance;
    string harmonyId = "com.arl1x.GawrGuraSharks";
    public static GameObject gawrguraPrefab;

    public IEnumerator Start()
    {
        harmonyInstance = new Harmony(harmonyId);
        harmonyInstance.PatchAll();
        var request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("gawrgura.assets"));
        yield return request;
        asset = request.assetBundle;
        gawrguraPrefab = asset.LoadAsset<GameObject>("GawrGura");
        ToggleDisplay(true);
        Log("mod has been successfully loaded!");
    }

    public static List<SkinnedMeshRenderer> GetSharkSkins()
    {
        List<SkinnedMeshRenderer> result = new List<SkinnedMeshRenderer>();
        foreach (SkinnedMeshRenderer s in FindObjectsOfType<SkinnedMeshRenderer>())
            if (s.name.Contains("Shark"))
                result.Add(s);
        return result;
    }

    public static void ToggleDisplay(bool val)
    {
        if (val)
        {
            Debug.Log("Replacing Sharks with Gwar Guras...");
            foreach (SkinnedMeshRenderer s in GetSharkSkins())
            {
                s.enabled = false;
                Transform parent = s.transform.parent.parent;
                if (!parent.Find("GAWRGURA_OBJECT"))
                {
                    GameObject gawrgura = Instantiate(gawrguraPrefab, parent.position, parent.rotation, parent);
                    gawrgura.name = "GAWRGURA_OBJECT";
                    gawrgura.transform.Rotate(90.0f, 0.0f, 0.0f);
                    gawrgura.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
                    gawrgura.transform.localPosition = new Vector3(0, 1, -2);
                }
            }
        }
        else
        {
            Debug.Log("Removing Gawr Guras...");
            int i = 0;
            foreach (SkinnedMeshRenderer s in GetSharkSkins())
            {
                s.enabled = true;
                Transform gawrgura = s.transform.parent.parent.Find("GAWRGURA_OBJECT");
                if (gawrgura)
                {
                    DestroyImmediate(gawrgura.gameObject);
                    i++;
                }
            }
            Debug.Log("Successfully unloaded " + i + " Gawr Gura! XD");
        }
    }

    public void OnModUnload()
    {
        ToggleDisplay(false);
        harmonyInstance.UnpatchAll(harmonyId);
        asset.Unload(true);
        Log("mod has been unloaded!");
    }
}

[HarmonyPatch(typeof(Network_Host_Entities), "CreateAINetworkBehaviour", new Type[] { typeof(AI_NetworkBehaviourType), typeof(Vector3), typeof(float), typeof(uint), typeof(uint), typeof(LandmarkEntitySpawner) })]
public static class HarmonyPatch_SpawnEntity
{
    private static void Postfix(AI_NetworkBehaviourType behaviourType)
    {
        if (behaviourType == AI_NetworkBehaviourType.Shark)
            GawrGuraShark.ToggleDisplay(true);
    }
}